/*-----------------------------------------------------------------------------*
// include
*-----------------------------------------------------------------------------*/
#include "harktool.h"




/*-----------------------------------------------------------------------------*
// extern
*-----------------------------------------------------------------------------*/
extern struct GLOBAL  g;






/*-----------------------------------------------------------------------------*
* calcSysImp
*
*
*
*-----------------------------------------------------------------------------*/
void harktoolcli_calcsysimp(int  argc ,   char   *argv[ ])
{




    harktool_LogI("harktoolcli_calcsysimp start");



    if (argc < 18) {
        harktool_LogE("argument not enough　[calcsysimp]");
        printf("\n\n");
        harktool_help("calcsysimp");
        harktool_Exit(EXIT_FAILURE);
    }



    int  tsporigwav     = 0 ;
    int  tsporigchannel = 0 ;
    int  sigmax         = 0 ;
    int  syncaddfreq    = 0 ;
    int  samplingfreq   = 0 ;
    int  syncaddoffset  = 0 ;
    int  outchannellist = 0 ;
    int  nmic           = 0 ;
    int  inputwave      = 0 ;
    int  outputpath     = 0 ;
    int  outimpfilepath = 0 ;
    int  cnt            = 0 ;
    int  outlist[64];
    int  posid =0;



    while (cnt< argc) {
        if (strcmp(argv[cnt] , "--tsporigwav") == 0) {
            cnt++;
            tsporigwav = cnt;

        } else if (strcmp(argv[cnt] , "--tsporigchannel") == 0) {
            cnt++;
            tsporigchannel = cnt;

        } else if (strcmp(argv[cnt] , "--sigmax") == 0) {
            cnt++;
            sigmax = cnt;
        } else if (strcmp(argv[cnt] , "--syncaddfreq") == 0) {
            cnt++;
            syncaddfreq = cnt;
        } else if (strcmp(argv[cnt] , "--sampling-freq") == 0) {
            cnt++;
            samplingfreq = cnt;
        } else if (strcmp(argv[cnt] , "--posid") == 0) {
            cnt++;
            posid = cnt;
        } else if (strcmp(argv[cnt] , "--syncaddoffset") == 0) {
            cnt++;
            syncaddoffset = cnt ;
        } else if (strcmp(argv[cnt] , "--outchannellist") == 0) {
            cnt++;
            outchannellist = cnt;
        } else if (strcmp(argv[cnt] , "--inputwave") == 0) {
            cnt++;
            inputwave = cnt;
        } else if (strcmp(argv[cnt] ,"--outputpath") == 0) {
            cnt++;
            outputpath = cnt;
        } else if (strcmp(argv[cnt] ,"--outimpfilepath") == 0) {
            cnt++;
            outimpfilepath = cnt;
        }

        cnt++;
    }




    harktool_calcSysImp(16
                        , "--tsporigwav"      , argv[tsporigwav]
                        , "--tsporigchannel"  , argv[tsporigchannel]
                        , "--sigmax"          , atoi(argv[sigmax])
                        , "--syncaddfreq"     , atoi(argv[syncaddfreq])
                        , "--syncaddoffset"   , atoi(argv[syncaddoffset])
                        , "--outchannellist"  , argv[outchannellist]
                        , "--inputwave"       , argv[inputwave]
                        , "--outputpath"      , argv[outputpath]
                       );



    // get nmic
    nmic = harktool_split(argv[outchannellist]  , "," ,  outlist) ;



    harktool_mergeFltFile(argv[outputpath]               //char *in_file_path
                          , argv[outimpfilepath]       // char *out_file_path
                          , atoi(argv[posid])           // position id
                          , outlist                     // channel list
                          , nmic                        // num mic
                          , atoi(argv[samplingfreq]));  // samplerate

    //void harktool_mergeFltFile( char *in_file_path , char *out_file_path , int *outlist  int nmic , int samplerate);



    /*--------------------------------------------------*/
    // end proc
    /*--------------------------------------------------*/
    harkio_Log_printf(harkio_Log_Info, "@ harktoolcli_calcsysimp normal end");

    harktool_Exit(EXIT_SUCCESS);



}






/*-----------------------------------------------------------------------------*
*
*
*

*
*-----------------------------------------------------------------------------*/
// void harktool_helpCalcSysImp()
// {
//     printf("./calcSysImp [Required Argument]  \n");
//     printf("calculate impluse from TSP wave\n");
//     printf("(fix time: 2013/10/30, compile time: %s %s)\n",__DATE__ ,__TIME__);
//     printf("\n");
//     printf("[Required Argument]\n");
//     printf("\t--tsporigflt \"file_name\"       : playing tsp file(float-data) when recording tsp wave.\n");
//     printf("\t--tsporigwav \"file_name\"       : playing tsp file(PCM-wave) when recording tsp wave.\n");
//     printf("\t--tsporigchannel N               : select use cahnnel of tsp origin file(PCM-wave).\n");
//     printf("\t--sigmax N                       : set optional signal max for tsp original file\n");
//     printf("\t                                   (not working on using --tsporigwav.)\n");
//     printf("\t--samplebyframe N                : sample by one frame(default = 16384) \n");
//     printf("\t--syncaddfreq N                  : frequency of synchronous addition(default = 16) \n");
//     printf("\t--syncaddoffset N                : start position of synchronous addition(default = 16384) \n");
//     printf("\t--searchoffset \"N,N\"           : using searched start position.(search start pos, search end pos is required.) \n");
//     printf("\t--outchannellist \"N,N,...\"     : select calulating channel.(first channel is ch0.)\n");
//     printf("\t--inputwave  \"file_name\"       : 16bit or 24bit , 8ch or 10ch or 16ch , 16kHz wave format\n");
//     printf("\t                                   48KHz is not available yet.\n");
//     printf("\t--outputpath \"outputpath/head\" : its extention is k.flt where k is ch number.\n");
//     printf("\t                                    each imp file is 32bit float mono 1-ch raw data\n");
//     printf("\t  eg.) when outimpfilehead = 'a', file names are 'a_ch1.flt', 'a_ch2.flt', ...\n");
//     printf("\n");


//     //	printf("\t--enableHPF Lfreq,Hfreq  : enable HighPassFilter.\n");


// }







