/*-----------------------------------------------------------------------------*
*
*
*
*
*-----------------------------------------------------------------------------*/
#include "harktool.h"



//global 構造体
struct GLOBAL  g;








/*-----------------------------------------------------------------------------*
* main処理
*
*
*
*-----------------------------------------------------------------------------*/
int main(int argc , char *argv[])
{
    if (argc <= 1) {
    	harkio_Log_printf(harkio_Log_Error ,"Main Argument Error");
        harkio_Log_printf(harkio_Log_Error ,"\n\nHow to use [harktool5 --help]\n\n");
        exit(EXIT_FAILURE);
    }

    /*--------------------------------------------------*/
    /*   help                                           */
    /*--------------------------------------------------*/
    if (strcmp(argv[1] , "--help") == 0) {
        harktool_help("ALL");
        exit(EXIT_SUCCESS);
    }

    if (argc == 2) {
    	harkio_Log_printf(harkio_Log_Error ,"Main Argument Error");
    	harkio_Log_printf(harkio_Log_Error ,"\n\nHow to use [harktool5 --help]\n\n");
        exit(EXIT_FAILURE);
    }

    //init level
    harkio_Log_setLevel(harkio_Log_Error);

    int i;

    for (i=1 ; i < argc ; i++) {
        // ログLevel
        if (strcmp(argv[i] , "--logLevel") == 0) {

            strncpy(g.argv.loglevel , argv[i+1] , 9);

            if (strcmp(argv[i+1] , "WARNING") == 0) {
                harkio_Log_setLevel(harkio_Log_Warning);
            } else if (strcmp(argv[i+1] , "INFO") == 0) {
                harkio_Log_setLevel(harkio_Log_Info);
            } else if (strcmp(argv[i+1] , "DEBUG") == 0) {
                harkio_Log_setLevel(harkio_Log_Debug);
            } else {
                harkio_Log_setLevel(harkio_Log_Error);
            }
        }
    }

    harkio_Log_printf(harkio_Log_Info, "@ harktool5 start");



    if (strcmp(argv[2] , "--help") == 0) {
        harktool_help(argv[1]);
        harktool_Exit(EXIT_SUCCESS);
    }

    /*--------------------------------------------------*/
    // calcsysimp only
    /*--------------------------------------------------*/
    if (strcmp(argv[1] , "calcsysimp") == 0) {
        harktoolcli_calcsysimp(argc , argv);

    } else {
        /*--------------------------------------------------*/
        // 初期化
        /*--------------------------------------------------*/
        harktool_init();


        // get arguments
        harktool_getArguments(argc , argv);



        //インパルス応答から伝達関数生成
        if (strcmp(argv[1] , "calctfimp") == 0) {
            harktoolcli_calctfimp();
        }
        //TSP録音から伝達関数作成処理
        else if (strcmp(argv[1] , "calctfrec") == 0) {
            harktoolcli_calctfrec();
        }
        //幾何計算から伝達関数作成処理
        else if (strcmp(argv[1] , "calctfgeo") == 0) {
            harktoolcli_calctfgeo();
        }
        //くちTSP録音から伝達関数作成処理
        else if (strcmp(argv[1] , "calctfmouth") == 0) {
            harktoolcli_calctfmouth();
        } else {
            harkio_Log_printf(harkio_Log_Error, "Main Argument Error");
            exit(EXIT_FAILURE);
        }
    }

    exit(EXIT_SUCCESS);

}//








/*-----------------------------------------------------------------------------*
* check Arguments
*
*

*
*-----------------------------------------------------------------------------*/
void harktool_getArguments(int argc , char** argv)
{

    int cnt;


    cnt = 1;
    printf("[%s] :\n"               , argv[1]);


    while (cnt < argc) {
        // mic file
        if (strcmp(argv[cnt]      , "--mic-list") == 0) {
            cnt++;
            strcpy(g.argv.mic_file , argv[cnt]);
            printf("--mic-list       [%s]\n", g.argv.mic_file);
        }
        // TSP List file
        else if (strcmp(argv[cnt] , "--tsp-list") == 0) { //tsp001.wav
            cnt++;
            strcpy(g.argv.tsp_file , argv[cnt]);
            printf("--tsp-list       [%s]\n", g.argv.tsp_file);
        }
        // ImpulseList file
        else if (strcmp(argv[cnt] , "--impulse-list") == 0) { //imp001.wav
            cnt++;
            strcpy(g.argv.impulse_file , argv[cnt]);
            printf("--impulse-list   [%s]\n", g.argv.impulse_file);
        }
        // noise file
        else if (strcmp(argv[cnt] , "--noise-list") == 0) { //imp001.wav
            cnt++;
            strcpy(g.argv.noise_file , argv[cnt]);
            printf("--noise-list     [%s]\n", g.argv.noise_file);
        }
        //作成する伝達関数のzip
        else if (strcmp(argv[cnt] , "--output-file") == 0) {
            cnt++;
            strcpy(g.argv.output , argv[cnt]);    // hark.zip
            printf("--output-file    [%s]\n", g.argv.output);
        }
        // 引数 伝達関数種別 MUSIC /GSS (output_type)
        else if (strcmp(argv[cnt]  , "--output-type") == 0) { //MUSIC , GSS
            cnt++;

            if (strcmp(argv[cnt]      , "SEP") == 0) {
                g.argv.tf_type = SEP;
            } else if (strcmp(argv[cnt] , "LOC") == 0) {
                g.argv.tf_type = LOC;
            } else if (strcmp(argv[cnt] , "LOC_SEP") == 0) {
                g.argv.tf_type = LOC_SEP;
            } else {
                g.argv.tf_type = LOC;
            }

            printf("--output-type    [%d]\n", g.argv.tf_type);
        }
        // 正規化(SRC)
        else if (strcmp(argv[cnt] , "--normalize-src") == 0) {
            cnt++;
            g.argv.normalize_src = atoi(argv[cnt]);
            printf("--normalize-src  [%d]\n", g.argv.normalize_src);
        }
        // 正規化(mic)
        else if (strcmp(argv[cnt] , "--normalize-mic") == 0) {
            cnt++;
            g.argv.normalize_mic = atoi(argv[cnt]);
            printf("--normalize-mic  [%d]\n", g.argv.normalize_mic);
        }
        // 正規化(freq)
        else if (strcmp(argv[cnt] , "--normalize-freq") == 0) {
            cnt++;
            g.argv.normalize_freq = atoi(argv[cnt]);
            printf("--normalize-freq [%d]\n", g.argv.normalize_freq);
        }
        //
        else if (strcmp(argv[cnt] , "--direct-length") == 0) {
            cnt++;
            g.argv.direct_sound_length = atoi(argv[cnt]);
            printf("--direct-length  [%d]\n", g.argv.direct_sound_length);
        }
        //
        else if (strcmp(argv[cnt] , "--start") == 0) {
            cnt++;
            g.argv.start = atoi(argv[cnt]);
            printf("--start  [%d]\n", g.argv.start);
        }
        //
        else if (strcmp(argv[cnt] , "--end") == 0) {
            cnt++;
            g.argv.end = atoi(argv[cnt]);
            printf("--end  [%d]\n", g.argv.end);
        }
        //
        else if (strcmp(argv[cnt] , "--mch") == 0) {
            cnt++;
            g.argv.mch = atoi(argv[cnt]);
            printf("--mch  [%d]\n", g.argv.mch);
        }
        //
        else if (strcmp(argv[cnt] , "--nch") == 0) {
            cnt++;
            g.argv.nch = atoi(argv[cnt]);
            printf("--nch  [%d]\n", g.argv.nch);
        }
        //
        else if (strcmp(argv[cnt] , "--fltlen") == 0) {
            cnt++;
            g.argv.fltlen = atoi(argv[cnt]);
            printf("--fltlen  [%d]\n", g.argv.fltlen);
        }
        // Shift length for TF calculation [Integer]
        else if (strcmp(argv[cnt] , "--hop") == 0) {
            cnt++;
            g.argv.hop = atoi(argv[cnt]);
            printf("--hop  [%d]\n", g.argv.hop);
        }
        // Head margin of impulse responces in samples [Integer(Default:0)]
        else if (strcmp(argv[cnt] , "--headmargin") == 0) {
            cnt++;
            g.argv.headmargin = atoi(argv[cnt]);
            printf("--headmargin  [%d]\n",g.argv.headmargin);
        }
        // Enables adding white noise to escape unstable zero signal [Bool]
        else if (strcmp(argv[cnt] , "--enable-wn") == 0) {
            cnt++;
            g.argv.enable_wn = atoi(argv[cnt]);
            printf("--enable-wn  [%d]\n", g.argv.enable_wn);
        }
        // Level of white noise. Set enable_wn=true if you want to use this. [Double]
        else if (strcmp(argv[cnt] , "--wn-level") == 0) {
            cnt++;
            g.argv.wn_level = atof(argv[cnt]);
            printf("--wn-level  [%f]\n", g.argv.wn_level);
        }
        // Enable normalizing output TF
        else if (strcmp(argv[cnt] , "--enable-normalize") == 0) {
            cnt++;
            g.argv.enable_normalize = atoi(argv[cnt]);
            printf("--enable-normalize  [%d]\n", g.argv.enable_normalize);
        }
        //
        else if (strcmp(argv[cnt] , "--help") == 0) {
            harktool_help(argv[1]);
            harktool_Exit(EXIT_SUCCESS);
        }

        cnt++;
    }
}//
















/*-----------------------------------------------------------------------------*
* 初期化
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_init()
{


    g.argv.tf_type             = 0                                        ; // 引数 伝達関数種別 MUSIC /GSS
    g.argv.direct_sound_length = 0                                        ;
    g.argv.normalize_src       = 0                                        ; // 正規化(SRC) 引数
    g.argv.normalize_mic       = 0                                        ; // 正規化(mic) 引数
    g.argv.normalize_freq      = 0                                        ; // 正規化(freq)引数
    g.argv.mch                 = 1                                        ; // mouthTSP

    //	g.argv.cutLow_freq         = 0                                        ; //引数 CalcSysImpで使用
//	g.argv.cutHigh_freq        = 0                                        ; //引数　CalcSysImpで使用

    memset(g.argv.mic_file     , '\0' , sizeof(g.argv.mic_file))     ;  // mic file (引数)
    memset(g.argv.tsp_file     , '\0' , sizeof(g.argv.tsp_file))     ;  // TSP List file (引数)
    memset(g.argv.impulse_file , '\0' , sizeof(g.argv.impulse_file)) ;  // ImpulseList file      (引数)
    memset(g.argv.noise_file   , '\0' , sizeof(g.argv.noise_file))   ;  // noise file (引数)
    memset(g.argv.input        , '\0' , sizeof(g.argv.input))        ;  // 引数 ( tsp001.wav)
    memset(g.argv.output       , '\0' , sizeof(g.argv.output))       ;  // 引数 作成する伝達関数のzip (hark.zip)



    g.Nsrc             = 0                                                ; // 音源数
    g.Nmic             = 0                                                ; // mic数
    g.Nfft             = 0                                                ; // fft数 // harkio_Config
    g.SyncAverage      = 0                                                ; // harkio_Config_get
    g.TspOffset        = 0                                                ; // harkio_Config_get
    g.PeakSearchFrom   = 0                                                ; // harkio_Config_get
    g.PeakSearchTo     = 0                                                ; // harkio_Config_get
    g.SamplingRate     = 0                                                ; // harkio_Config_get
    g.SignalMax        = 0                                                ; // harkio_Config_get
    g.TspLength        = 0                                                ; // harkio_Config_get
    g.OrgTspPath       = NULL                                             ;
    memset(g.ChannelList , '\0' , sizeof(g.ChannelList))                  ;
    g.TFvect           = NULL                                             ; // 伝達関数領域
    g.TmpTFvect        = NULL                                             ; // 伝達関数 作業領域
    g.TFsize           = 0                                                ; // 伝達関数領域のsize(Nsrc * Nmic * ( Nfft/2 + 1) )
    g.buff_a           = NULL                                             ; // fft前のデータ
    g.buff_A           = NULL                                             ; // fft後のデータ
    g.buff_w           = NULL                                             ; //
    g.IRvect           = NULL                                             ; // インパルス応答格納領域
    g.TmpIRvect        = NULL                                             ; // インパルス応答 計算用TEMP領域
    g.IRsize           = 0                                                ; // インパルス応答格納領域のsize(Nsrc * nmix * Nfft)
    g.mic_xml          = NULL                                             ; // 伝達関数作成時のマイク位置
    g.tsp_xml          = NULL                                             ; // 伝達関数作成時の
    g.impulse_xml      = NULL                                             ; // 伝達関数作成時の
    g.noise_xml        = NULL                                             ; // 伝達関数作成時の;
    g.src_xml          = NULL                                             ; // 定位した音源（音源定位結果保存形式）
    g.MicPosVect       = NULL                                             ; // mic position 格納領域
    g.SrcPosVect       = NULL                                             ; // src position 格納領域
    memset(g.PosMean , '\0' , sizeof(g.PosMean))                          ;    // 平均値
    g.Loctf            = NULL                                             ; // 定位伝達関数格納
    g.Septf            = NULL                                             ; // 分離伝達関数格納
    g.TF               = NULL                                             ; // 伝達関数
    g.mic_xml          = NULL                                             ; // 伝達関数作成時のマイク位置
    g.tsp_xml          = NULL                                             ; // 伝達関数作成時の
    g.impulse_xml      = NULL                                             ; // 伝達関数作成時の
    g.noise_xml        = NULL                                             ; // 伝達関数作成時の;
    g.src_xml          = NULL                                             ; // 定位した音源（音源定位結果保存形式）
    memset(g.tmp.date_time , '\0' , BUFFSIZE)                             ; // ディレクトリ名作成用現在日時分秒
    memset(g.tmp.tsp_path  , '\0' , BUFFSIZE)                             ; // tspファイル格納パス   TSP storage path
    memset(g.tmp.ir_path   , '\0' , BUFFSIZE)                             ; // irファイル格納パス
    memset(g.tmp.tf_path   , '\0' , BUFFSIZE)                             ; // tfファイル格納パス
    g.tmp.flt_path         = NULL                                         ; // CalcSysimpで作成したインパルス応答ファイル格納path名(Nsrc分)
    g.tmp.tsp_wav_name     = NULL                                         ; // TSPファイル名(Nsrc分)
    memset(g.tmp.outimpfilehead ,'\0', PATH_LEN)                          ; // CalcSysyImpで使用するpath+header部
    g.wav.file_size   = 0                                                 ;
    g.wav.total_frame = 0                                                 ;
    g.wav.data        = NULL                                              ;
    g.tmp.flt_path     = NULL                                             ; // CalcSysimpで作成したインパルス応答ファイル格納path名(Nsrc分)
    g.tmp.tsp_wav_name = NULL                                             ; // TSPファイル名(Nsrc分)

}










/*-----------------------------------------------------------------------------*
* helpを表示する
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_help(char* funcname)
{


    if (strcmp(funcname ,  "ALL") == 0) {
        printf("                                                                 \n");
        printf("                                                                 \n");
        printf("[NAME:]                                                          \n");
        printf("  HARKTOOL                                                       \n");
        printf("                                                                 \n");
        printf("[Description:]\n");
        printf("  HARKTOOL is a tool for visualization and generation of the transfer function\n");
        printf("                                                                 \n");
        printf("[Function List:]                                                 \n");
        printf("  1. calctfimp                                                   \n");
        printf("       Generate transfer function from impulse responses         \n");
        printf("          Usage : harktool5 calctfimp --help                     \n");
        printf("                                                                 \n");
        printf("  2. calctfrec                                                   \n");
        printf("       Generate transfer function from TSPs                      \n");
        printf("          Usage : harktool5 calctfrec --help                     \n");
        printf("                                                                 \n");
        printf("  3. calctfgeo                                                   \n");
        printf("       Generate transfer function by geometric calculation       \n");
        printf("          Usage : harktool5 calctfgeo --help                     \n");
        printf("                                                                 \n");
        printf("  4. calctfmouth                                                 \n");
        printf("       Generate transfer function from mouth TSPs                \n");
        printf("          Usage : harktool5 calcsysimp --help                    \n");
        printf("                                                                 \n");
        printf("  5. calcsysimp                                                  \n");
        printf("       calculate impluse response from TSP wave                  \n");
        printf("          Usage : harktool5 calcsysimp --help                    \n");
        printf("                                                                 \n");
        printf("                                                                 \n");
    }



    else if (strcmp(funcname ,  "calctfimp") == 0) {
        printf("                                                                 \n");
        printf("                                                                 \n");
        printf("[Function :]                                                     \n");
        printf("  calctfimp                                                      \n");
        printf("                                                                 \n");
        printf("[Description:]                                                   \n");
        printf("  Generate transfer function from impulse responses              \n");
        printf("                                                                 \n");
        printf("[Usage:]                                                         \n");
        printf("  harktool5 calctfimp  [options]                                 \n");
        printf("                                                                 \n");
        printf("[options]                                                        \n");
        printf(" --mic-list        : microphone list file                        \n");
        printf("                       ex. microphone.xml                        \n");
        printf("                                                                 \n");
        printf(" --impulse-list    : impulse list file                           \n");
        printf("                       ex. impulse.xml                           \n");
        printf("                                                                 \n");
        printf(" --output-type     : transfer function type                      \n");
        printf("                       LOC     : Localization transfer function  \n");
        printf("                       SEP     : Separation transfer function    \n");
        printf("                                                                 \n");
        printf(" --output-file     : output transfer function zip file path      \n");
        printf("                       ex. /path/transfer.zip                    \n");
        printf("                                                                 \n");
        printf(" --direct-length   : direct sound length                         \n");
        printf("                                                                 \n");
        printf(" --normalize-src   : normalize by src                            \n");
        printf("                       disable : 0                               \n");
        printf("                       enable  : 1                               \n");
        printf("                                                                 \n");
        printf(" --normalize-mic   : normalize by mic                            \n");
        printf("                       disable : 0                               \n");
        printf("                       enable  : 1                               \n");
        printf("                                                                 \n");
        printf(" --normalize-freq  : normalize by frequency                      \n");
        printf("                       disable : 0                               \n");
        printf("                       enable  : 1                               \n");
        printf("                                                                 \n");
        printf(" --logLevel        : log information level                       \n");
        printf("                       ERROR   : ERROR information only          \n");
        printf("                       WARNING : ERROR + WARNING                 \n");
        printf("                       INFO    : ERROR + WARNING + INFO          \n");
        printf("                       DEBUG   : ERROR + WARNING + INFO + DEBUG  \n");
        printf("                                                                 \n");
        printf("                                                                 \n");
    }


    else if (strcmp(funcname ,  "calctfrec") == 0) {
        printf("                                                                 \n");
        printf("                                                                 \n");
        printf("[Function :]                                                     \n");
        printf("  calctfrec                                                      \n");
        printf("                                                                 \n");
        printf("[Description:]                                                   \n");
        printf("  Generate transfer function from TSPs                           \n");
        printf("                                                                 \n");
        printf("[Usage:]                                                         \n");
        printf("  harktool5 calctfrec  [options]                                 \n");
        printf("                                                                 \n");
        printf("[options]                                                        \n");
        printf(" --mic-list        : microphone list file                        \n");
        printf("                       ex. microphone.xml                        \n");
        printf("                                                                 \n");
        printf(" --tsp-list        : tsp list file                               \n");
        printf("                       ex. tsp.xml                               \n");
        printf("                                                                 \n");
        printf(" --output-type     : transfer function type                      \n");
        printf("                       LOC     : Localization transfer function  \n");
        printf("                       SEP     : Separation transfer function    \n");
        printf("                                                                 \n");
        printf(" --output-file     : output transfer function zip file path      \n");
        printf("                       ex. /path/transfer.zip                    \n");
        printf("                                                                 \n");
        printf(" --direct-length   : direct sound length                         \n");
        printf("                                                                 \n");
        printf(" --normalize-src   : normalize by src                            \n");
        printf("                       disable : 0                               \n");
        printf("                       enable  : 1                               \n");
        printf("                                                                 \n");
        printf(" --normalize-mic   : normalize by mic                            \n");
        printf("                       disable : 0                               \n");
        printf("                       enable  : 1                               \n");
        printf("                                                                 \n");
        printf(" --normalize-freq  : normalize by frequency                      \n");
        printf("                       disable : 0                               \n");
        printf("                       enable  : 1                               \n");
        printf("                                                                 \n");
        printf(" --logLevel        : log information level                       \n");
        printf("                       ERROR   : ERROR information only          \n");
        printf("                       WARNING : ERROR + WARNING                 \n");
        printf("                       INFO    : ERROR + WARNING + INFO          \n");
        printf("                       DEBUG   : ERROR + WARNING + INFO + DEBUG  \n");
        printf("                                                                 \n");
        printf("                                                                 \n");
    }


    else if (strcmp(funcname ,  "calctfgeo") == 0) {
        printf("                                                                 \n");
        printf("                                                                 \n");
        printf("[Function :]                                                     \n");
        printf("  calctfgeo                                                      \n");
        printf("                                                                 \n");
        printf("[Description:]                                                   \n");
        printf("  Generate transfer function by geometric calculation            \n");
        printf("                                                                 \n");
        printf("[Usage:]                                                         \n");
        printf("  harktool5 calctfgeo  [options]                                 \n");
        printf("                                                                 \n");
        printf("[options]                                                        \n");
        printf(" --mic-list        : microphone list file                        \n");
        printf("                       ex. microphone.xml                        \n");
        printf("                                                                 \n");
        printf(" --tsp-list        : tsp list file                               \n");
        printf("                       ex. tsp.xml                               \n");
        printf("                                                                 \n");
        printf(" --output-type     : transfer function type                      \n");
        printf("                       LOC     : Localization transfer function  \n");
        printf("                       SEP     : Separation transfer function    \n");
        printf("                                                                 \n");
        printf(" --output-file     : output transfer function zip file path      \n");
        printf("                       ex. /path/transfer.zip                    \n");
        printf("                                                                 \n");
        printf(" --direct-length   : direct sound length                         \n");
        printf("                                                                 \n");
        printf(" --normalize-src   : normalize by src                            \n");
        printf("                       disable : 0                               \n");
        printf("                       enable  : 1                               \n");
        printf("                                                                 \n");
        printf(" --normalize-mic   : normalize by mic                            \n");
        printf("                       disable : 0                               \n");
        printf("                       enable  : 1                               \n");
        printf("                                                                 \n");
        printf(" --normalize-freq  : normalize by frequency                      \n");
        printf("                       disable : 0                               \n");
        printf("                       enable  : 1                               \n");
        printf("                                                                 \n");
        printf(" --logLevel        : log information level                       \n");
        printf("                       ERROR   : ERROR information only          \n");
        printf("                       WARNING : ERROR + WARNING                 \n");
        printf("                       INFO    : ERROR + WARNING + INFO          \n");
        printf("                       DEBUG   : ERROR + WARNING + INFO + DEBUG  \n");
        printf("                                                                 \n");
        printf("                                                                 \n");
    }

    else if (strcmp(funcname ,  "calctfmouth") == 0) {
        printf("                                                                 \n");
        printf("                                                                 \n");
        printf("[Function :]                                                     \n");
        printf("  calctfmouth                                                    \n");
        printf("                                                                 \n");
        printf("[Description:]                                                   \n");
        printf("  Generate transfer function from mouth TSPs                    \n");
        printf("                                                                 \n");
        printf("[Usage:]                                                         \n");
        printf("  harktool5 calctfmouth  [options]                               \n");
        printf("                                                                 \n");
        printf("[options]                                                        \n");
        printf(" --mic-list        : microphone list file                        \n");
        printf("                       ex. microphone.xml                        \n");
        printf("                                                                 \n");
        printf(" --tsp-list        : tsp list file                               \n");
        printf("                       ex. tsp.xml                               \n");
        printf("                                                                 \n");
        printf(" --output-type     : transfer function type                      \n");
        printf("                       LOC     : Localization transfer function  \n");
        printf("                       SEP     : Separation transfer function    \n");
        printf("                                                                 \n");
        printf(" --output-file     : output transfer function zip file path      \n");
        printf("                       ex. /path/transfer.zip                    \n");
        printf("                                                                 \n");
        printf(" --start           : start point for TF calculation in sample    \n");
        printf("                                                                 \n");
        printf(" --end             : end point for TF calculation in sample      \n");
        printf("                                                                 \n");
        printf(" --mch             : channel index of the voice input (1-base)   \n");
        printf("                                                                 \n");
        printf(" --nch             : channel selector for micarray channels (max channel)\n");
        printf("                                                                 \n");
        printf(" --fltlen          : number of samples output as TF              \n");
        printf("                                                                 \n");
        printf(" --hop             : shift length for TF calculation             \n");
        printf("                                                                 \n");
        printf(" --headmargin      : head margin of impulse responces in samples \n");
        printf("                       (default=0)                               \n");
        printf("                                                                 \n");
        printf(" --enable-wn       : enable adding white noise                   \n");
        printf("                       disable : 0                               \n");
        printf("                       enable  : 1                               \n");
        printf("                                                                 \n");
        printf(" --wn-level        : level of white noise (with enable-wn option)\n");
        printf("                                                                 \n");
        printf(" --enable-normalize: enable normalizing output TF                \n");
        printf("                       disable : 0                               \n");
        printf("                       enable  : 1                               \n");
        printf("                                                                 \n");
        printf(" --direct-length   : direct sound length                         \n");
        printf("                                                                 \n");
        printf(" --logLevel        : log information level                       \n");
        printf("                       ERROR   : ERROR information only          \n");
        printf("                       WARNING : ERROR + WARNING                 \n");
        printf("                       INFO    : ERROR + WARNING + INFO          \n");
        printf("                       DEBUG   : ERROR + WARNING + INFO + DEBUG  \n");
        printf("                                                                 \n");
        printf("                                                                 \n");
    }

    else if (strcmp(funcname ,  "calcsysimp") == 0) {
        printf("                                                                           \n");
        printf("                                                                           \n");
        printf("[Function :]                                                               \n");
        printf("  calcsysimp                                                               \n");
        printf("                                                                           \n");
        printf("[Description:]                                                             \n");
        printf("  Calculate impluse responses from a recorded TSP wave                     \n"); 
        printf("                                                                           \n");
        printf("[Usage:]                                                                   \n");
        printf("  harktool5 calcsysimp  [options]                                          \n");
        printf("                                                                           \n");
        printf("[options]                                                                  \n");
        printf(" --tsporigflt      : original tsp filename (float-data format)             \n");
        printf("                                                                           \n");
        printf(" --tsporigwav      : original tsp filename (PCM-wave format)               \n");
        printf("                       (either of the above two should be given.)          \n");
        printf("                                                                           \n");
        printf(" --tsporigchannel  : channel number (for the PCM-wave tsp)                 \n");
        printf("                                                                           \n");
        printf(" --sigmax          : maximum signal value (for float-format tsp) (optional)\n");
        printf("                                                                           \n");
        printf(" --samplebyframe   : number of samplings per frame          (default=16384)\n");
        printf("                                                                           \n");
        printf(" --syncaddfreq     : frequency of synchronous addition      (default=16)   \n");
        printf("                                                                           \n");
        printf(" --syncaddoffset   : start position of synchronous addition (default=16384)\n");
        printf("                                                                           \n");
        printf(" --searchoffset    : start and end point of the search range               \n");
        printf("                       this enables to search a start position and use it  \n");
        printf("                                                                           \n");
        printf(" --outchannellist  : select channel(s) to calculate                        \n");
        printf("                       (zero-based, comma separated)                       \n");
        printf("                                                                           \n");
        printf(" --inputwave       : recorded wav file                                     \n");
        printf("                       supported formats are:                              \n");
        printf("                        16/24 bit, 8/10/16 ch, 16 KHz (48 KHz unsupported) \n");
        printf("                                                                           \n");
        printf(" --outputpath      : path prefix for output impulse response files         \n");
        printf("                       output file will be 32bit float monoral raw data    \n");
        printf("                       named '<prefix>_ch1.flt', '<prefix>_ch2.flt', ...   \n");
        printf("                                                                           \n");
        printf("                                                                           \n");
    }

    else {
        harkio_Log_printf(harkio_Log_Error ,"\n\nHow to use [harktool5 --help]\n\n");
        exit(EXIT_FAILURE);
    }
}//









#if 0
/*-----------------------------------------------------------------------------*
* 終了処理
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_Exit(int exit_type)
{

    if (exit_type == EXIT_SUCCESS) {
        harktool_LogI("harktool normal end");
        harktool_freeMemory();
        exit(EXIT_SUCCESS);
    }


    harktool_LogE("harktool abnormal end");

    harktool_freeMemory();

    exit(EXIT_FAILURE);

}//end
#endif





